#include "FiveWin.ch"

//----------------------------------------------------------------------------//

function PrgNew( oMruPrgs )

   PrgOpen( cGetNewFileName( "programs\NONAM", "prg" ), oMruPrgs )

return nil

//----------------------------------------------------------------------------//

function PrgOpen( cPrgName, oMruPrgs )

   local oWndEdit, oBar, oBtn, oGet, oIco, oCrsPen, oFont, oRow, oCol
   local cText

   DEFAULT cPrgName := cGetFile( "Clipper Program (*.prg) | *.prg",;
                                 "Select a PRG", 1, "Programs" )
   if Empty( cPrgName )
      return nil
   else
      if File( cPrgName )
         cText = MemoRead( cPrgName )
      else
         cText  = '#include "FiveWin.ch"' + CRLF + CRLF
         cText += "//----------------------------------------------" + ;
                  "------------------------------//" + CRLF + CRLF
         cText += "function Main()" + CRLF + CRLF + CRLF + CRLF
         cText += "return nil" + CRLF + CRLF
         cText += "//----------------------------------------------" + ;
                  "------------------------------//" + CRLF
      endif
   endif

   DEFINE ICON oIco RESOURCE "Write"

   DEFINE CURSOR oCrsPen RESOURCE "Pen"

   DEFINE WINDOW oWndEdit FROM 1, 1 TO 23, 33 ;
      TITLE "Program: " + cNoPath( cNoExt( cPrgName ) ) MDICHILD ;
      ICON oIco

   DEFINE BUTTONBAR oBar 3D SIZE 33, 33 OF oWndEdit

   DEFINE BUTTON RESOURCE "ToDisk" OF oBar ;
      TOOLTIP "Save" ;
      MESSAGE "Save to disk" ;
      ACTION ( oGet:Save(), MemoWrit( cPrgName, cText ), Tone( 900, 1 ) )

   DEFINE BUTTON RESOURCE "Compile" GROUP OF oBar ;
      TOOLTIP "Compile" ;
      MESSAGE "Compile this program" ;
      ACTION ( oGet:Save(),;
               MemoWrit( cPrgName, cText ),;
               WinExec( "..\tools\wClipper.exe " + cNoExt( cPrgName ) ) )

   DEFINE BUTTON RESOURCE "Link" OF oBar ;
      TOOLTIP "Link" ;
      MESSAGE "Link this program" ;
      ACTION WinExec( "link.pif " + cNoExt( cPrgName ) )

   DEFINE BUTTON RESOURCE "Exec"    OF oBar ;
      TOOLTIP "Run" ;
      MESSAGE "Execute this program" ;
      ACTION WinExec( cNoExt( cPrgName ) )

   DEFINE BUTTON OF oBar GROUP RESOURCE "Comment" TOOLTIP "Insert comment" ;
      ACTION oGet:Paste( "//" + Replicate( "-", 76 ) + "//" + CRLF + CRLF ),;
             oGet:SetFocus()

   DEFINE BUTTON OF oBar RESOURCE "Function" TOOLTIP "function ... return" ;
      ACTION oGet:Paste( "function " + CRLF + CRLF + CRLF + CRLF + ;
                         "return nil" + CRLF + CRLF ),;
             oGet:SetFocus()

   DEFINE BUTTON OF oBar RESOURCE "IfEndif" TOOLTIP "if ... endif" ;
      ACTION oGet:Paste( "   if " + CRLF + CRLF + "   endif" + CRLF + CRLF ),;
             oGet:SetFocus()

   DEFINE BUTTON OF oBar RESOURCE "DoCase" TOOLTIP "do case ... endcase" ;
      ACTION oGet:Paste( "   do case " + CRLF + CRLF + ;
                         "      case" + CRLF + CRLF + ;
                         "      case" + CRLF + CRLF + ;
                         "      otherwise" + CRLF + CRLF + ;
                         "   endcase" + CRLF + CRLF ),;
             oGet:SetFocus()

   DEFINE BUTTON OF oBar RESOURCE "DoWhile" TOOLTIP "while ... end" ;
      ACTION oGet:Paste( "   while " + CRLF + CRLF + ;
                         "   end" + CRLF + CRLF ),;
             oGet:SetFocus()

   DEFINE BUTTON oBtn OF oBar GROUP RESOURCE "Functions" ;
      TOOLTIP "Functions List" ACTION FuncList( oBtn, oGet )

   SET MESSAGE OF oWndEdit TO ""

   DEFINE MSGITEM oCol OF oWndEdit:oMsgBar PROMPT "Col: 0" SIZE 70
   DEFINE MSGITEM oRow OF oWndEdit:oMsgBar PROMPT "Row: 0" SIZE 70

   DEFINE FONT oFont NAME "Arial" SIZE 6, 15 BOLD

   @ 0, 0 GET oGet VAR cText MEMO OF oWndEdit ;
      CURSOR oCrsPen FONT oFont ;
      ON CHANGE ( oRow:SetText( "Row: " + LTrim( Str( oGet:GetRow() ) ) ),;
                  oCol:SetText( "Col: " + LTrim( Str( oGet:GetCol() ) ) ) )

   oGet:bKeyDown = { | nKey | oRow:SetText( "Row: " + LTrim( Str( oGet:GetRow() ) ) ),;
                  oCol:SetText( "Col: " + LTrim( Str( oGet:GetCol() ) ) ), nil } 

   oWndEdit:SetControl( oGet )

   oGet:bRClicked = { || ThisInspect( oGet ) }

   ACTIVATE WINDOW oWndEdit ;
      VALID ( oMruPrgs:Save( cPrgName ), .t. )

return nil

//----------------------------------------------------------------------------//

function FuncList( oBtn, oGet )

   local oMenu
   local cText     := oGet:GetText()
   local n, nLines, cLine
   local aPos := { oBtn:nBottom - oBtn:nTop - 1, -1 }

   SysRefresh()
   nLines = oGet:GetLineCount()

   ClientToScreen( oBtn:hWnd, aPos )

   if At( "FUNCTION", Upper( cText ) ) == 0
      MsgAlert( "No functions declared in this PRG" )
      return nil
   endif

   CursorWait()

   MENU oMenu POPUP
      for n = 1 to nLines
         if At( "FUNCTION", Upper( cLine := oGet:GetLine( n ) ) ) != 0
            MENUITEM SubStr( cLine, 1, At( ")", cLine ) + 1 ) + Chr( 9 ) + ;
               cValToChar( n ) ;
               ACTION oGet:GoTo( Val( SubStr( oMenuItem:cPrompt,;
                      At( Chr( 9 ), oMenuItem:cPrompt ) + 1 ) ) ),;
                      oGet:SetFocus()
         endif
         SysRefresh()
      next
      SEPARATOR
      MENUITEM "Cancel Search"
   ENDMENU

   ACTIVATE POPUP oMenu OF oBtn:oWnd:oWnd AT aPos[ 1 ], aPos[ 2 ]

return nil

//----------------------------------------------------------------------------//
