#include "FiveWin.ch"

static oWndAreas

//------------------------------------------------------------------------//

function WorkAreas( oItemAreas )

   local oBrw, oBar
   local nAlias := 1
   local nPos   := 1

   if oWndAreas == nil

     oItemAreas:SetCheck( .t. )          // Toggle the PullDown MenuItem

     DEFINE WINDOW oWndAreas MDICHILD FROM 13, 1 TO 23, 75 ;
        TITLE "Work Areas Inspector" 

     DEFINE BUTTONBAR oBar OF oWndAreas

     DEFINE BUTTON OF oBar ACTION oBrw:Refresh()

      DEFINE BUTTON GROUP OF oBar RESOURCE "Indexes" ;
         ACTION Indexes( Alias( nAlias ) ) MESSAGE "Review Indexes information"

      DEFINE BUTTON OF oBar RESOURCE "Fields" ;
         MESSAGE "Review fields information"

      @ 0, 0 LISTBOX oBrw ;
         FIELDS xPadL( AllTrim( Str( nAlias, 3 ) ), 28 ), ;
                Alias( nAlias ), ;
                If( ( nAlias )->( BoF() ), "Yes", "No" ), ;
                If( ( nAlias )->( EoF() ), "Yes", "No" ), ;
                GetIndexKey( nAlias ),;
                xPadL( AllTrim( Str( ( nAlias )->( RecNo() ) ) ), 42 ), ;
                xPadL( AllTrim( Str( ( nAlias )->( RecCount() ) ) ), 42 ), ;
                GetRddName( nAlias ), ;
                xPadL( AllTrim( Str( ( nAlias )->( FCount() ) ) ), 42 ), ;
                xPadL( AllTrim( Str( ( nAlias )->( RecSize() ) ) ), 42 ) ;
         FIELDSIZES 34, 90, 32, 32, 40, 48, 48, 80, 48, 48 ;
         HEAD "Area", "Alias", "BOF", "EOF", "Index", "RecNo", "Total", "RDD", "Fields", "RecSize" ;
	 OF oWndAreas

     oBrw:bGoTop    = { || nAlias := GetFirstArea(), nPos := 1 }
     oBrw:bGoBottom = { || nAlias := GetLastArea(),  nPos := CountAreas() }
     oBrw:bSkip     = { | nWant, nDo | ;
                          nDo := Min( Max( nWant, 1 - nPos ),;
                          CountAreas() - nPos ), ;
                          nPos += nDo, nAlias := GetArea( nPos ), nDo }
     oBrw:bLogicLen = { || CountAreas() }

     oWndAreas:SetControl( oBrw )

     ACTIVATE WINDOW oWndAreas ;
        VALID ( oWndAreas := nil, oItemAreas:SetCheck( .f. ), .t. )

  endif

return nil

//----------------------------------------------------------------------------//

static function GetLastArea()

  local n := 1
	
  while ! Empty( Alias( n++ ) )
  end

return n

//----------------------------------------------------------------------------//

static function GetFirstArea()

  local n := 1
	
  while Empty( alias( n++ ) )
  end

return n

//----------------------------------------------------------------------------//

static function CountAreas()

  local n
  local nAreas := 0

  for n = 1 to 255
     if ! Empty( Alias( n ) )
        nAreas++
     endif
  next

return nAreas

//----------------------------------------------------------------------------//

static function GetArea( nArea )

  local n
  local nAreas := 0

  for n = 1 to 255
     if ! Empty( Alias( n ) )
        nAreas++
	if n == nArea
        return nAreas
      endif
    endif
  next

return nAreas

//----------------------------------------------------------------------------//

function GetWndAreas() ; return oWndAreas  // to export oWndAreas "      "

//----------------------------------------------------------------------------//
