// FiveWin - LIB files management functions !!!

#include "FiveWin.ch"

//----------------------------------------------------------------------------//

function Main( cLibName )

   local oDlg, oObjs, oPublics, oExterns
   local aModules, aPublics, aExterns
   local cModule, cPublic, cExtern
   local n

   DEFAULT cLibName := cGetFile( "*.lib", "Select a LIB file" )

   if ! lLibOpen( cLibName )
      MsgStop( "Can not open that LIB file!" )
      return nil
   endif

   aModules = aLibModule()

   for n = 1 to Len( aModules )
      aModules[ n ] = xPadR( aModules[ n ], 182 ) + ;
                      xPadL( Str( nModSize( n ) ), 50 )
   next

   SET 3DLOOK ON  

   DEFINE DIALOG oDlg RESOURCE "Main"

   REDEFINE SAY PROMPT LTrim( Str( Len( aModules ) ) ) + ;
                              " Modules" ;
      ID 10 OF oDlg

   REDEFINE LISTBOX oObjs VAR cModule ITEMS aModules ;
      ID 110 OF oDlg ;
      ON CHANGE ( aPublics := aModPublic( oObjs:GetPos() ),;
                  oPublics:SetItems( If( ! Empty( aPublics ), aPublics, { "" } ) ),;
                  aExterns := aModExtern( oObjs:GetPos() ),;
                  oExterns:SetItems( If( ! Empty( aExterns ), aExterns, { "" } ) ) )

   REDEFINE LISTBOX oPublics VAR cPublic ;
      ITEMS If( ! Empty( aModPublic( 1 ) ), aModPublic( 1 ), { "" } ) ;
      ID 120 OF oDlg

   REDEFINE LISTBOX oExterns VAR cExtern ;
      ITEMS If( ! Empty( aModExtern( 1 ) ), aModExtern( 1 ), { "" } ) ;
      ID 130 OF oDlg

   REDEFINE BUTTON ID 160 OF oDlg ;
      ACTION lModExtract( oObjs:GetPos() ), MsgBeep()

   ACTIVATE DIALOG oDlg CENTERED ;
      ON INIT oObjs:GoTop()

   lLibClose()

return nil

//----------------------------------------------------------------------------//
