// The new FiveWin messageBars !!!

#include "FiveWin.ch"

#define  CLOCK_ON         "Shows the clock at the MsgBar..."
#define  CLOCK_OFF        "Hides the clock at the MsgBar..."
#define  DATE_ON          "Shows the Date at the MsgBar..."
#define  DATE_OFF         "Hides the Date at the MsgBar..."
#define  KEYB_ON          "Shows the Keyboard status at the MsgBar..."
#define  KEYB_OFF         "Hides the KeyBoard status at the MsgBar..."
#define  NEW_ON           "Adds a new Item to the MsgBar..."
#define  NEW_OFF          "Removes an Item from the MsgBar..."
#define  CHG_COLOR        "Changes the color of the Items..."
#define  CHG_FONT         "Changes the font of the Items..."
#define  SALIR            "Exit from this app"
#define  MENU_CLOCK_ON    "&Clock On"
#define  MENU_CLOCK_OFF   "&Clock Off"
#define  MENU_DATE_ON     "&Date On"
#define  MENU_DATE_OFF    "&Date Off"
#define  MENU_KEYB_ON     "&Keyb On"
#define  MENU_KEYB_OFF    "&Keyb Off"
#define  MENU_NEW_ON      "&New MsgItem"
#define  MENU_NEW_OFF     "&Hide MsgItem"

static oWnd, oWndEdit, oBar, oWBar, oItem,;
       oBtnClock, oBtnDate, oBtnKeyb, oBtnNew,;
       oRow, oCol, aCoors, oFont, oMenu, oMenuitem,;
       oReloj, oDate, oKeyb, oNewItem, oBtn, oBtnExit 
   
static aColors, aFonts
static nColors, nFonts

//----------------------------------------------------------------------------//

function Main()

   aColors := Array( 5 )
   aFonts  := Array( 5 )

   DEFINE FONT aFonts[ 1 ] NAME "Arial" SIZE 0, 24 BOLD
   DEFINE FONT aFonts[ 2 ] NAME "Ms Sans Serif" SIZE 0, 8 BOLD
   DEFINE FONT aFonts[ 3 ] NAME "Ms Serif" SIZE 0, 12 BOLD
   DEFINE FONT aFonts[ 4 ] NAME "Arial" SIZE 0, 12 ITALIC
   DEFINE FONT aFonts[ 5 ] NAME "Ms Sans Serif" SIZE 0, 8

   aColors[ 1 ] = "w+*/r"
   aColors[ 2 ] = "r+/w+*"
   aColors[ 3 ] = "g+/w+*"
   aColors[ 4 ] = "w+*/b"
   aColors[ 5 ] = "b+/w"

   nColors := 1
   nFonts := 1

   SET 3DLOOK ON

   DEFINE WINDOW oWnd FROM 1, 1 TO 20, 70;
      TITLE "FiveWin powerfull new MsgBar" MDI;
      MENU BuildMenu() // COLOR "GR+*/RB"

   DEFINE BUTTONBAR oWBar 3D SIZE 33, 33 OF oWnd

   DEFINE BUTTON oBtnClock OF oWBar MESSAGE CLOCK_ON;
          FILE "..\BITMAPS\CLOCK.BMP";
          TOOLTIP "Show/Hide the clock" ;
          ACTION ChgCtrl( 1 )    
  
   DEFINE BUTTON oBtnDate OF oWbar MESSAGE DATE_ON;
          FILE "..\BITMAPS\CALENDAR.BMP";
          TOOLTIP "Show/Hide the Date" ;
          ACTION ChgCtrl( 2 )    
  
   DEFINE BUTTON oBtnKeyb OF oWBar MESSAGE KEYB_ON;
          FILE "..\BITMAPS\Select.BMP"; 
          TOOLTIP "Show/Hide the Keyboard status" ;
          ACTION ChgCtrl( 3 )    

   DEFINE BUTTON oBtnNew OF oWBar MESSAGE NEW_ON;
          FILE "..\BITMAPS\PLUS.BMP";
          TOOLTIP "Adds a new item" ;
          ACTION ChgCtrl( 4 )    

   DEFINE BUTTON oBtn OF oWBar ;
          MESSAGE "Opens a child window" ;
          FILE "..\BITMAPS\DLG.BMP";
          TOOLTIP "Opens a new window" ;
          ACTION ( oBtn:Disable(), WndEdit() )
          
   DEFINE BUTTON oBtnExit OF oWBar MESSAGE SALIR;
          FILE "..\bitmaps\Exit.Bmp";
          TOOLTIP "End this app" ;
          ACTION oWnd:End()

   SET MESSAGE OF oWnd TO "Testing the MsgBar" ;
       FONT oFont NOINSET

   ACTIVATE WINDOW oWnd MAXIMIZED

  AEval( aFonts, { | oFont | oFont:End() } )

return nil

//----------------------------------------------------------------------------//

function BuildMenu()
   
   MENU oMenu
      MENUITEM oMenuItem PROMPT "&Test Options"

      MENU
         MENUITEM oReloj PROMPT MENU_CLOCK_ON;
            MESSAGE CLOCK_ON;
            ACTION  ChgCtrl( 1 )
     
         MENUITEM oDate PROMPT MENU_DATE_ON;
            MESSAGE DATE_ON;
            ACTION  ChgCtrl( 2 )
     
         MENUITEM oKeyb PROMPT MENU_KEYB_ON;
            MESSAGE KEYB_ON;
            ACTION ChgCtrl( 3 )

         MENUITEM oNewItem PROMPT MENU_NEW_ON;
            MESSAGE NEW_ON;
            ACTION ChgCtrl( 4 )    

         SEPARATOR

         MENUITEM "&End..." ;
            ACTION If( MsgYesNo( "Want to exit ?" ), oWnd:End(),) ;
            MESSAGE "End this app"
      ENDMENU                           

      oMenu:AddMdi()              // Select automatic MDI support !!!

      oMenu:AddHelp( "FiveWin", "(c) FiveTech" )  // Automatic Help support !!!

   ENDMENU

return oMenu

//----------------------------------------------------------------------------//

static function ChgCtrl( nOpcion )

   Do Case
      Case nOpcion == 1
           If ! oWnd:oMsgBar:lClock
              oWnd:oMsgBar:ClockOn()
              oReloj:cMsg := CLOCK_OFF
              oReloj:SetCheck( .t. )
              oBtnClock:cMsg := CLOCK_OFF
           else
              oWnd:oMsgBar:ClockOff()
              oReloj:cMsg := CLOCK_ON
              oReloj:SetCheck( .f. )
              oMenu:Refresh()
              oBtnClock:cMsg := CLOCK_ON
         Endif

    Case nOpcion == 2
          If ! oWnd:oMsgBar:lDate
              oWnd:oMsgBar:DateOn()
              oDate:SetCheck( .t. )
              oDate:SetPrompt( DATE_OFF )
              oBtnDate:cMsg := DATE_OFF
          Else    
              oWnd:oMsgBar:DateOff()
              oDate:SetPrompt( DATE_ON )
              oDate:SetCheck( .f. )
              oBtnDate:cMsg := DATE_ON
              oWnd:oWndClient:Refresh(.f.)
          Endif

    Case nOpcion == 3
          If ! oWnd:oMsgBar:lKbd
             oWnd:oMsgBar:KeybOn()
             oKeyb:SetPrompt( KEYB_OFF )
             oKeyb:SetCheck( .t. )
             oBtnKeyb:cMsg := KEYB_OFF
          Else    
             oWnd:oMsgBar:KeybOff()
             oKeyb:SetPrompt( KEYB_ON )
             oKeyb:SetCheck( .f. )
             oBtnKeyb:cMsg := KEYB_ON
          Endif

    Case nOpcion == 4
          if oItem != Nil .and. oItem:nId != 0
             oWnd:oMsgBar:DelItem( oItem )
             oNewItem:SetPrompt( NEW_ON )
             oNewItem:SetCheck( .f. )
             oBtnNew:cMsg := NEW_ON
             oBtnNew:SetFile("..\bitmaps\plus.bmp")
          else
             oItem := TMsgItem():New( oWnd:oMsgBar, "Hello", 60, oFont,"R*/BG",,.t. )
             oNewItem:SetPrompt( NEW_OFF )
             oNewItem:SetCheck( .t. )
             oBtnNew:cMsg = NEW_OFF
             oBtnNew:SetFile( "..\bitmaps\minus.bmp" )
          endif
   endcase

Return Nil

//-------------------------------------------------------------------------//

static function ChgColor()

   oRow:nClrFore := aColors[ nColors ]
   oCol:nClrFore := aColors[ nColors ]
   oRow:Refresh()
   oCol:Refresh()

   If( ++nColors > 5, nColors := 1, )

return nil

//--------------------------------------------------------------------------//

static Function ChgFont()

   local n

   for n = 1 to Len( oWndEdit:oMsgBar:aItem )
       oWndEdit:oMsgBar:aItem[ n ]:oFont := aFonts[ nFonts ]
   next

   oWndEdit:oMsgBar:oFont := aFonts[ nFonts ]
   oWndEdit:oMsgBar:Refresh( .t. )

   If( ++nFonts > 5, nFonts := 1, )

return nil

//--------------------------------------------------------------------------//

static function WndEdit()

   DEFINE WINDOW oWndEdit MDICHILD OF oWnd ;
      FROM 2, 2 TO 20, 70 ;
      TITLE "Build so informative MsgBars!!!" COLOR "R+/W"
   
   DEFINE BUTTONBAR oBar OF oWndEdit

   DEFINE BUTTON OF oBar MESSAGE CHG_COLOR;
          FILE "..\BITMAPS\COLORS.BMP";
          ACTION ChgColor()    

   DEFINE BUTTON OF oBar MESSAGE CHG_FONT;
          FILE "..\BITMAPS\FONTS.BMP";
          ACTION ChgFont()    
   
   DEFINE BUTTON OF oBar ;
          MESSAGE "Close the child window" ;
          FILE "..\BITMAPS\EXIT.BMP";
          ACTION ( oWndEdit:End(), oBtn:Enable() )
   
   SET MESSAGE OF oWndEdit TO "So many possibilities" ;
      KEYBOARD CLOCK DATE CENTERED
   
   DEFINE MSGITEM oRow OF oWndEdit:oMsgBar SIZE 30 COLOR "R+/W"
   DEFINE MSGITEM oCol OF oWndEdit:oMsgBar SIZE 30 COLOR "R+/W"
   
   ACTIVATE WINDOW oWndEdit

   oWndEdit:bMMoved = { | nRow, nCol, nFlags | oRow:SetText( nRow ),;
                                               oCol:SetText( nCol ) }
return nil

//----------------------------------------------------------------------------//
