**    Last revision: June 18, 1995 at 10:49

***************************************************************************
* 
*  Test program for the Table [Traditional] Column Browse class
* 
*  This project was started by an original idea of Salim Anter of Instabul
* 
*  I have only added a little spit and polish. Harry Van Tassell
* 
***************************************************************************

#include "fivewin.ch"
#include "TCBrowse.ch"  


// always put TCBrowse.ch AFTER filewin.ch and TCBrowse.lib BEFORE fivewin.lib

Static MainWnd

Function Main()
         Local hBWCC

         // Set Exclusive Off
         Set Date Format "dd/mm/yyyy"

         SET 3DLOOK ON

         hBWCC  := LoadLibrary( "BWCC.DLL" )
         SET RESOURCES TO "TESTTCBR.DLL"               // Our stored screens

         DEFINE WINDOW MainWnd FROM 1, 1 TO 22, 75 ;
                TITLE "Test Columnar Browse 05/29/95" ;
                MENU BuildMenu()

         SET MESSAGE OF MainWnd TO "Great idea by Salim Anter" CENTERED

         USE Stok
         IF ! ( File("StokName.NTX") .and. File("MaliYet.NTX") )
           INDEX ON Stok->MaliYet  TO MaliYet
           INDEX ON Stok->StokName TO StokName
         ELSE
           SET INDEX TO StokName, MaliYet
         ENDIF

         ACTIVATE WINDOW MainWnd MAXIMIZED
         FreeLibrary( hBWCC )
         SET RESOURCES TO

Return( NIL )

Function BuildMenu
         local oMenu

         MENU oMenu
              MENUITEM OemToAnsi( "&Create" ) ;
                       ACTION NewBrowse( )

              MENUITEM OemToAnsi( "&Browse" ) ;
                       ACTION Browse( )

              MENUITEM OemToAnsi( "&oDbfBrowse" ) ;
                       ACTION oDbfBrowse( )

              MENUITEM "E&xit"  ;
                       ACTION If( MsgYesNo( OemToAnsi( "Programdan kmak stiyormusunuz ?" ),"Exit"  ),;
                       MainWnd:End(),)

         ENDMENU
Return( oMenu )

#define OBM_CLOSE           32754
#define OBM_UPARROW         32753
#define OBM_DNARROW         32752
#define OBM_CHECKBOXES      32759
#define OBM_CHECK           32760
#define OCR_NORMAL          32512
#define OCR_CROSS           32515

Function NewBrowse( )
         Static aX
         Local oDlg, oBrw, oCol, oFont, oSay

  Local _hOn  := LoadBitMap(0, OBM_CHECK) // Use OEM system resources
  Local _hOff := Chr(160) // This will be treated as if it were bitmap

         if aX == nil
          aX := Array(3)
          aX[1] := LoadBitMap( GetResources(), "Z_Green_X")
          aX[2] := LoadBitMap( GetResources(), "Z_Red_X")
          aX[3] := LoadBitMap( GetResources(), "Z_Blank")
         endif


         DEFINE FONT oFont NAME "System" SIZE 8, 16 BOLD  // 6, 15

         DEFINE DIALOG oDlg of MainWnd NAME "Aktivite"

         REDEFINE BROWSE oBrw  ID 999  OF oDlg ;
           MESSAGE "You may open multi-copies, DblCkick to edit, "+ ;
           "1st column frozen" FONT oFont

         //  FONT oFont
         // COLOR CLR_BLACK, RGB( 255, 255, 235) ;  // Cream color

        // oBrw:SetContext( TWAContext():New() )

        // oBrw:nClrForeHead := CLR_WHITE
        // oBrw:nClrBackHead := CLR_BLUE

      // set header colors when it is an ordered and/or  controlling column
      //oBrw:nOClrForeHead := CLR_HRED  // mark all ordered colms forground
      //oBrw:nOClrBackHead := CLR_HBLUE // controlling ordered colm background

		  // code block that is evaluated when the seek expression 
		  // is changed. This can be used to diplay the expression on the
		  // screen so that the used knows what is happening.
//		  oBrw:bSeekChange  := {|| oSay:Refresh() }

          oBrw:lLogicDrop := .t.  // use crazy logic dropbox
         // oBrw:lNoLiteBar := .t.
         // oBrw:lNoGrayBar := .t.
         oBrw:lNoHScroll := .t.  // don't use that pesky horiz scroll bar
         oBrw:nAdjColumn := 3    // expand this column to flush table right
         // oBrw:lMChange   := .f.  // disable mousemove
          oBrw:nFreeze := 3         // 0 disables freezing 1 is leftmost
         oBrw:hBmpCursor := LoadBitmap( GetResources(), "Z_Triangle" )

         oBrw:bLDblClick := { | nRow, nCol | EditCell( oBrw, nRow, nCol ) }

         // Next Lines shows how column object is used
         ADD COLUMN TO  oBrw DATA "" SIZE 15 // blank cursor colm

         ADD COLUMN TO  oBrw NOBAR ;
            BITMAP DATA If ( Stok->FATURA > Stok->BAKIYE , aX[1] , ;
                     If ( Stok -> FATURA < Stok->BAKIYE , aX[2], aX[3] ) )


         // oBrw:AddColumn( TCColumn( ):New( ;
         //              OemToAnsi( "Stok" ), ; // Optional Header
         //              { | | OemToAnsi( Stok ->STOKNAME ) }, ; // Data bBlock
         //              , ;    // Optional Picture Clause for display & editing
         //              , ;    // Optional bForeGnd Color, Default ListBox
         //              , ;    // Optional bBackGnd Color, Default ListBox
         //              , ;    // Optional Alignement Default "LEFT"
         //              100, ; // Optional Size In Pixels, will auto default
         //              , ;    // Optional lBitMap Flag 
         //              , ;    // Optional Editable T/F, Default .f.
         //              , ;    // Optional cMsg when editing
         //              , ;    // Optional bValid for editing
         //              , ) )  // Optional cError msg for valid failure
         // 

         ADD COLUMN TO BROWSE oBrw ;
           DATA  OemToAnsi( Stok ->STOKNAME ) TAG StokName ;
           HEADER "Stok" SIZE 100

         ADD COLUMN TO BROWSE oBrw ;
            DATA FieldWBlock("BAKIYE", Select("Stok")) ; // we can edit it
            HEADER "Bakiye" OEM ALIGN RIGHT  ;
            PICTURE "###,###.##" EDITABLE WIDTH 70  PIXELS ;
            COLOR If( Stok->BAKIYE < 0, CLR_RED, CLR_BLACK), {||CLR_GREEN } ;
            MESSAGE "Enter a negative number" ;
            VALID {|o| o:varGet() >= 0} ;
            ERROR MESSAGE "Value must be"+CRLF+"positive or 0" 

          //  oBrw:aColumns[3]:nWidth := 60   // access second comumn


         oBrw:AddColumn( TCColumn( ):New( OemToAnsi( "Fatura" ) , ;
                   FieldWBlock("Fatura", Select("Stok")), ;
                    "###,###.##" , nil, nil, DT_RIGHT, 90 , nil, .t.) )


        //    DATA If ( Stok->FATURA > Stok->BAKIYE , "+" , ;
        //        If ( Stok -> FATURA < Stok->BAKIYE , "-", " " ) ) ;

         DEFINE COLUMN oCol ;
            DATA If ( Stok->FATURA > Stok->BAKIYE , _hOn , _hOff) BITMAP;
            NOHILITE SIZE 15 COLOR "N/R" CENTER

         oBrw:AddColumn( oCol )

//         oBrw:AddColumn( TCColumn( ):New(  OemToAnsi( "Maliyet" ) , { | | Stok -> MALIYET }, "##,###,###" ,,, DT_RIGHT, 90 ) )

         ADD COLUMN TO oBrw ALIGN RIGHT TAG "MaliYet" SIZE 100 ;
            DATA Stok -> MALIYET PICTURE "##,###,###"  ;
            HEAD "Maliyet"

         ADD COLUMN TO oBrw ALIGN RIGHT ;
            HEAD "Ciro" DATA FieldBlock("CIRO") ;
            PICT "@Z #,###,###.##" SIZE 90 ;
            EDIT VALID {|o| o:varGet() < 0}  ;
            MESSAGE "Current data causes lots of errors" ;
            ERROR MESSAGE "Value Must be"+CRLF+"Less than 0" 

         ADD COLUMN TO BROWSE oBrw ;
            HEADER "Devirtarih"  ALIGN CENTER  ;
            DATA FieldBlock("Devirtarih") PICTURE "@D" EDIT


         ADD COLUMN TO  oBrw  TITLE "L"  PICT "Y"  SIZE 15 ;
          DATA  Stok->FATURA > Stok->BAKIYE  EDITABLE // but not savable

         // ADD COLUMN TO  oBrw  HEADER "first space"
         // ADD COLUMN TO  oBrw  HEADER "second space"
         // ADD COLUMN TO  oBrw  HEADER "third space"
         // ADD COLUMN TO  oBrw 

         REDEFINE BUTTON ID IDOK  OF oDlg ACTION oDlg:End( ) ;
           MESSAGE "Get outta here"

	       REDEFINE SAY oSay VAR oBrw:cSeek  ID 211 OF oDlg ;
            COLORS CLR_WHITE, CLR_CYAN 
	
         oBrw:bSeekChange  := {|| oSay:Refresh() }

         REDEFINE BUTTON ID 101 OF oDlg ;
           ACTION oBrw:SwitchCols(5, 9):Exchange(3, 6) ;
           MESSAGE "Switch columns 5 and 9, exchange columns 3 and 6"

         REDEFINE BUTTON ID 102 OF oDlg ;
           ACTION ( If(oBrw:oCtx != Nil, oBrw:oCtx:Display(), nil ), ;
           oBrw:SetFocus() )   MESSAGE "Display Context"

         REDEFINE BUTTON ID 103 OF oDlg ;
           ACTION oBrw:Report() ;
           MESSAGE "Print a Report"


         ACTIVATE DIALOG oDlg CENTERED NOWAIT

Return( NIL )

//----------------------------------------------------------------------------//

Function oDbfBrowse( )
         Static aX
         Local oDlg, oBrw, oCol, oFont
         local oDbf, oCtx, oSay

         if aX == nil
          aX := Array(3)
          aX[1] := LoadBitMap( GetResources(), "Z_Green_X")
          aX[2] := LoadBitMap( GetResources(), "Z_Red_X")
          aX[3] := LoadBitMap( GetResources(), "Z_Blank")
         endif



         DEFINE FONT oFont NAME "System" SIZE 8, 16 BOLD  // 6, 15

         DEFINE DIALOG oDlg of MainWnd NAME "Aktivite"

         REDEFINE COLUMN BROWSE oBrw  ID 999  OF oDlg ;
           COLOR CLR_BLACK, RGB( 255, 255, 235) ;  // Cream color
           MESSAGE "You may open multi-copies, DblCkick to edit, "+ ;
           "1st column frozen" FONT oFont

         //  FONT oFont
         // COLOR CLR_BLACK, RGB( 255, 255, 235) ;  // Cream color


         // oBrw:nClrForeHead := CLR_WHITE
         // oBrw:nClrBackHead := CLR_BLUE

         oBrw:nClrBackHead :=  CLR_HGRAY
         oBrw:nClrForeHead :=  CLR_BLACK

          oBrw:lLogicDrop := .t.  // use crazy logic dropbox
         // oBrw:lNoLiteBar := .t.
         oBrw:lNoGrayBar := .t.
         //oBrw:lNoHScroll := .t.  // don't use that pesky horiz scroll bar
         // oBrw:lMChange   := .f.  // disable mousemove
         oBrw:nAdjColumn := 3    // expand this column to flush table right
         oBrw:nFreeze := 2       // freeze first two cols


         oBrw:hBmpCursor := LoadBitmap( GetResources(), "Z_Finger" )

         oBrw:bLDblClick := { | nRow, nCol | EditCell( oBrw, nRow, nCol ) }


         Select Stok
         DATABASE oDbf 
         // MULTIDBF oDbf ALIAS Stok  OEM CONVERT 
         oDbf:GoTop()
         oBrw:SetoDbf( oDbf )

         // oCtx := TWAContext():New()
         // oBrw:SetContext( oCtx )

         #xtranslate oDbf:Stok: => oDbf:
         // Next Lines shows how column object is used with oDbf:Stok

         ADD COLUMN TO BROWSE oBrw  DATA oBrw:oDbf:Stok:RecNo() ;
             SIZE 30 NOBAR CENTER COLOR CLR_BLACK, CLR_HGRAY ;
             HEADER "No"

         ADD COLUMN TO  oBrw NOHILITE;
            BITMAP DATA If ( oBrw:oDbf:Stok:FATURA > oBrw:oDbf:Stok:BAKIYE , aX[1] , ;
                     If ( oBrw:oDbf:Stok:FATURA < oBrw:oDbf:Stok:BAKIYE , aX[2], aX[3] ) )

/****************************
         oBrw:AddColumn( TCColumn( ):New( ;
                      OemToAnsi( "Stok" ), ; // Optional Header
                      { || oBrw:oDbf:Stok:STOKNAME }, ; // Data bBlock
                      , ;    // Optional Picture Clause for display & editing
                      , ;    // Optional bForeGnd Color, Default ListBox
                      , ;    // Optional bBackGnd Color, Default ListBox
                      , ;    // Optional Alignement Default "LEFT"
                      100, ; // Optional Size In Pixels, will auto default
                      , ;    // Optional lBitMap Flag 
                      , ;    // Optional Editable T/F, Default .f.
                      , ;    // Optional cMsg when editing
                      , ;    // Optional bValid for editing
                      , ) )  // Optional cError msg for valid failure

*////////////////////////////////

         ADD TO BROWSE oBrw  oDBF FIELD StokName  ALIAS Stok ; 
            HEADER "Stok" OEM ALIGN LEFT  ;
            WIDTH 100  PIXELS ;
            EDIT MESSAGE "Enter a 'funny char'" 

         ADD TO BROWSE oBrw  oDBF FIELD Bakiye  ALIAS Stok ; 
            HEADER "Bakiye" OEM ALIGN RIGHT  ;
            PICTURE "###,###.##"  WIDTH 70  PIXELS ;
            COLOR If( oBrw:oDbf:Stok:BAKIYE < 0, CLR_RED, Nil), {||CLR_GREEN } ;
            MESSAGE "Enter a negative number" ;
            EDIT VALID {|o| o:varGet() >= 0} ;
            ERROR MESSAGE "Value must be"+CRLF+"positive or 0" 

          //  oBrw:aColumns[3]:nWidth := 60   // access second comumn

         oBrw:AddColumn( TCColumn( ):New( OemToAnsi( "Fatura" ) , ;
                   {||oBrw:oDbf:Stok:Fatura}, ;
                    "###,###.##" , nil, nil, DT_RIGHT, 90 , nil, .t.) )

         DEFINE COLUMN oCol ;
            DATA If ( oBrw:oDbf:Stok:FATURA > oBrw:oDbf:Stok:BAKIYE , "+" , ;
                If ( oBrw:oDbf:Stok:FATURA < oBrw:oDbf:Stok:BAKIYE , "-", " " ) ) ;
            SIZE 15 COLOR "N/R" CENTER NOBAR

         oBrw:AddColumn( oCol )

         oBrw:AddColumn( TCColumn( ):New(  OemToAnsi( "Maliyet" ) , { | | oBrw:oDbf:Stok:MALIYET }, "##,###,###" ,,, DT_RIGHT, 90 ) )

         ADD COLUMN TO oBrw oDBF Ciro ALIAS Stok ;
            HEAD "Ciro" ALIGN RIGHT ;
            PICT "@Z #,###,###.##" SIZE 90 ;
            EDIT VALID {|o| o:varGet() < 0} ;
            MESSAGE "Current data causes lots of errors" ;
            ERROR MESSAGE "Value Must be"+CRLF+"Less than 0" 

         ADD COLUMN TO BROWSE oBrw DATA oBrw:oDbf:Stok:Devirtarih ;
            HEADER "Devirtarih"  ALIGN CENTER  ;
            PICTURE "@D" EDIT

         ADD COLUMN TO  oBrw  TITLE "L"  PICT "Y"  SIZE 15 ;
          DATA  oBrw:oDbf:Stok:FATURA > oBrw:oDbf:Stok:BAKIYE ; // but not savable
          EDIT VALID IF x == "Yes" ;
          ERROR MESSAGE "Only True is allowed"

         // ADD COLUMN TO  oBrw  HEADER "first space"
         // ADD COLUMN TO  oBrw  HEADER "second space"
         // ADD COLUMN TO  oBrw  HEADER "third space"
         // ADD COLUMN TO  oBrw 

         REDEFINE BUTTON ID IDOK  OF oDlg ACTION ( oDlg:End() );
           MESSAGE "Get outta here"

	       REDEFINE SAY oSay VAR oBrw:cSeek  ID 211 OF oDlg ;
            COLORS CLR_WHITE, CLR_CYAN 
	
         oBrw:bSeekChange  := {|| oSay:Refresh() }

         REDEFINE BUTTON ID 101 OF oDlg ;
           ACTION oBrw:SwitchCols(5, 9):Exchange(3, 6) ;
           MESSAGE "Switch columns 5 and 9, exchange columns 3 and 6"

         REDEFINE BUTTON ID 102 OF oDlg ;
           ACTION ( If(oBrw:oCtx != Nil, oBrw:oCtx:Display(), nil ), ;
           oBrw:SetFocus() )   MESSAGE "Display Context"

         REDEFINE BUTTON ID 103 OF oDlg ;
           ACTION oBrw:Report() ;
           MESSAGE "Print a Report"

         ACTIVATE DIALOG oDlg CENTERED NOWAIT

Return( NIL )

//----------------------------------------------------------------------------//

Function oDbfBlock( )

return nil
