#include "FiveWin.ch"

#define BM_SETSTYLE  WM_USER + 4
#define DLGC_DEFPUSHBUTTON  16     //0x0010
#define GWL_STYLE           (-16)
#define DLGC_BUTTON        8192 //0x2000

//----------------------------------------------------------------------------//

CLASS TButton FROM TControl

   DATA   bAction
   DATA   lDefault

   METHOD New( nRow, nCol, cCaption, oWnd, bAction, nWidth, nHeight,;
               nHelpId, oFont, lDefault, lPixel, lDesign, cMsg,;
               lUpdate, bWhen, bValid ) CONSTRUCTOR

   METHOD ReDefine( nId, bAction, oWnd, nHelpId, cMsg,;
                    lUpdate, bWhen, bValid, cPrompt ) CONSTRUCTOR

   METHOD Click() INLINE If( ::bAction != nil, Eval( ::bAction ),),;
                         Super:Click(),;
                         ::SendMsg( BM_SETSTYLE, BS_DEFPUSHBUTTON, 1 )

   METHOD cGenPRG()

   METHOD GotFocus()

   METHOD LostFocus()

   METHOD MouseMove( nRow, nCol, nKeyFlags ) INLINE ;  // Standard Behavior
                     Super:MouseMove( nRow, nCol, nKeyFlags ), nil

   METHOD cToChar() INLINE Super:cToChar( "BUTTON" )

   METHOD Colors( hDC ) INLINE  0

   METHOD KeyDown( nKey, nFlags )

   METHOD Init( hDlg )

ENDCLASS

//----------------------------------------------------------------------------//

METHOD New( nRow, nCol, cCaption, oWnd, bAction, nWidth, nHeight, ;
            nHelpId, oFont, lDefault, lPixel, lDesign, cMsg,;
            lUpdate, bWhen, bValid ) CLASS TButton

   local nFntWidth  := If( oFont != nil, oFont:nWidth,   7 )
   local nFntHeight := If( oFont != nil, oFont:nHeight, 10 )

   DEFAULT cCaption := "&Button",;
           oWnd     := GetWndDefault(),;
           nWidth   := ( Len( cCaption ) + 2 ) * nFntWidth,;
           nHeight  := nFntHeight + Int( nFntHeight / 4 ),;
           nHelpId  := 100,;
           lDefault := .f., lPixel := .f., lDesign := .f., lUpdate := .f.

   ::cCaption  = cCaption
   ::nTop      = nRow * If( ! lPixel, nFntHeight + Int( nFntHeight / 4 ), 1 )
   ::nLeft     = nCol * If( ! lPixel, nFntWidth, 1 )
   ::nBottom   = ::nTop  + nHeight
   ::nRight    = ::nLeft + nWidth
   ::nHelpId   = nHelpId
   ::bAction   = bAction
   ::oWnd      = oWnd
   ::oFont     = oFont
   ::nStyle    = nOR( WS_CHILD, WS_VISIBLE, WS_TABSTOP, WS_CLIPSIBLINGS,;
                     If( lDefault, BS_DEFPUSHBUTTON, 0 ) )
                     // If( lDesign, WS_THICKFRAME, 0 ) )
   ::nId       = ::GetNewId()
   ::lDrag     = lDesign
   ::lCaptured = .f.
   ::cMsg      = cMsg
   ::lUpdate   = lUpdate
   ::bWhen     = bWhen
   ::bValid    = bValid
   ::lDefault  = lDefault

   if ! Empty( oWnd:hWnd )
      ::Create( "BUTTON" )
      oWnd:AddControl( Self )
   else
      oWnd:DefControl( Self )
   endif

return nil

//----------------------------------------------------------------------------//

METHOD ReDefine( nId, bAction, oWnd, nHelpId, cMsg,;
                 lUpdate, bWhen, bValid, cPrompt ) CLASS TButton

   ::nId       = nId
   ::bAction   = bAction
   ::hWnd      = 0
   ::nHelpId   = nHelpId
   ::oWnd      = oWnd
   ::lCaptured = .f.
   ::lDrag     = .f.
   ::cMsg      = cMsg
   ::lUpdate   = lUpdate
   ::bWhen     = bWhen
   ::bValid    = bValid
   ::cCaption  = cPrompt

   oWnd:DefControl( Self )

return nil

//----------------------------------------------------------------------------//

METHOD cGenPRG() CLASS TButton

   local cPrg := ""

   ::CoorsUpdate()

   cPrg += CRLF + ;
           "   @ " + Str( ::nTop, 3 ) + ", " + Str( ::nLeft, 3 ) + ;
           ' BUTTON "' + ::cCaption + '" SIZE ' + ;
           Str( ::nRight - ::nLeft + 1, 3 ) + ", " + ;
           Str( ::nBottom - ::nTop + 1, 3 ) + ;
           " PIXEL OF oWnd ;" + CRLF + ;
           '      ACTION MsgInfo( "Not defined yet!" )' + CRLF

return cPrg

//----------------------------------------------------------------------------//

METHOD GotFocus() CLASS TButton

   if ! ::lDrag
      if ::oWnd:ChildLevel( TDialog() ) == 0 .or. ;
         ( ::oWnd:oWnd != nil .and. ::oWnd:oWnd:ClassName() == "TFOLDER" )
         ::SendMsg( BM_SETSTYLE, BS_DEFPUSHBUTTON, 1 )
      endif
   endif

return Super:GotFocus()

//----------------------------------------------------------------------------//

METHOD LostFocus() CLASS TButton

   if ! ::lDrag
      if ::oWnd:ChildLevel( TDialog() ) == 0 .or. ;
         ( ::oWnd:oWnd != nil .and. ::oWnd:oWnd:ClassName() == "TFOLDER" )
         ::SendMsg( BM_SETSTYLE, BS_PUSHBUTTON, 1 )
      endif
   endif

return Super:LostFocus()

//----------------------------------------------------------------------------//

METHOD KeyDown( nKey, nFlags ) CLASS TButton

   do case
      case nKey == VK_UP .or. nKey == VK_LEFT
           ::oWnd:GoPrevCtrl( ::hWnd )
           return 0

      case nKey == VK_DOWN .or. nKey == VK_RIGHT
           ::oWnd:GoNextCtrl( ::hWnd )
           return 0

      case nKey == VK_RETURN
           PostMessage( ::hWnd, FM_CLICK )    // fire the button's action
           return 0
   endcase

return Super:KeyDown( nKey, nFlags )

//----------------------------------------------------------------------------//

METHOD Init( hDlg ) CLASS TButton

   Super:Init( hDlg )
   ::lDefault = lAnd( GetWindowLong( ::hWnd, GWL_STYLE ), BS_DEFPUSHBUTTON )

   if ! Empty( ::cCaption )
      SetWindowText( ::hWnd, ::cCaption )
   endif

return nil

//----------------------------------------------------------------------------//
