// New FiveWin MRU Technology !!!

// MRU means: "Most Recent Used" and let you automatically manage
// MRU lists on your menus !!! See SAMPLES\TestMru.prg for a test!

// (c) FiveTech 1993-5

#include "FiveWin.ch"

//----------------------------------------------------------------------------//

CLASS TMru

   DATA   aItems, nMaxItems
   DATA   cIniFile, cSection, cMsg
   DATA   oMenu, nMenuPos, bAction

   METHOD New( cIniFile, cSection, nMaxItems, cMsg, bAction,;
               oMenu, nMenuPos ) CONSTRUCTOR

   METHOD Save( uNewValue )

ENDCLASS

//----------------------------------------------------------------------------//

METHOD New( cIniFile, cSection, nMaxItems, cMsg, bAction, oMenu, nMenuPos ) ;
                                                                    CLASS TMru

   local oIni, n, cValue, oItem, lExist := .f.

   DEFAULT nMaxItems := 10, cMsg := "Open this file",;
           oMenu := LastMenu(), nMenuPos  := LastItemPos()

   ::aItems    = {}
   ::nMaxItems = nMaxItems
   ::cIniFile  = cIniFile
   ::cSection  = cSection
   ::bAction   = bAction
   ::oMenu     = oMenu
   ::nMenuPos  = nMenuPos
   ::cMsg      = cMsg

   INI oIni FILENAME cIniFile

      for n = 1 to nMaxItems

         GET cValue SECTION cSection ENTRY AllTrim( Str( n ) ) OF oIni ;
            DEFAULT ""

         if ! Empty( cValue )

            if ! lExist
               lExist = .t.
               SEPARATOR
            endif

            MENUITEM oItem ;
               PROMPT "&" + Str( n, If( n < 10, 1, 2 ) ) + " " + ;
               cValue MESSAGE cMsg ;
               BLOCK { | oItem | Eval( bAction, NoNumber( oItem:cPrompt ),;
                                       oItem ) }

            AAdd( ::aItems, oItem )
         endif

      next
   ENDINI

return nil

//----------------------------------------------------------------------------//

METHOD Save( uNewValue ) CLASS TMru

   local oItem, oIni, n, nAt

   uNewValue = "&1 " + cValToChar( uNewValue )

   if Len( ::aItems ) == 0
      oItem = TMenuItem():New()             // Separator
      ::oMenu:Insert( oItem, ::nMenuPos + 1 )
   endif

   nAt = AScan( ::aItems, { | oItem | NoNumber( oItem:cPrompt ) == ;
                NoNumber( uNewValue ) } )

   if nAt != 0
      ::aItems[ nAt ]:Enable()
   endif

   if nAt == 0 .and. Len( ::aItems ) < ::nMaxItems
      oItem = TMenuItem():New( uNewValue, ::cMsg, .f., .t.,;
          { | oItem | Eval( ::bAction, NoNumber( oItem:cPrompt ), oItem ) } )
      AAdd( ::aItems, nil )
      AIns( ::aItems, 1 )
      ::aItems[ 1 ] = oItem
      ::oMenu:Insert( oItem, ::nMenuPos + 2 )
   endif

   if nAt == 0
      for n = Len( ::aItems ) to 2 step -1
          ::aItems[ n ]:SetPrompt( "&" + Str( n, If( n > 9, 2, 1 ) ) + ;
                                   " " + NoNumber( ::aItems[ n ]:cPrompt ) )
      next
   else
      for n = nAt to 2 step -1
          ::aItems[ n ]:SetPrompt( "&" + Str( n, If( n > 9, 2, 1 ) ) + ;
                                   " " + NoNumber( ::aItems[ n - 1 ]:cPrompt ) )
          if ! ::aItems[ n - 1 ]:lActive
             ::aItems[ n ]:Disable()
          else
             ::aItems[ n ]:Enable()
          endif
      next
   endif
   ::aItems[ 1 ]:Enable()
   ::aItems[ 1 ]:SetPrompt( uNewValue )

   INI oIni FILENAME ::cIniFile
      for n = 1 to Len( ::aItems )
         SET SECTION ::cSection ENTRY AllTrim( Str( n ) ) OF oIni ;
            TO NoNumber( ::aItems[ n ]:cPrompt )
      next
   ENDINI

return nil

//----------------------------------------------------------------------------//

static function NoNumber( cPrompt )

return SubStr( cPrompt, At( " ", cPrompt ) + 1 )

//----------------------------------------------------------------------------//
