**    Last revision: June 3, 1995 at 10:15

/***************************************************************************

 The Column class for the Table [Traditional] Column Browse class

 This project was started by an original idea of Salim Anter of Instabul

 I have only added a little spit and polish. Harry Van Tassell

 5-15-95 TWS added column search 

 6-03-95 Made GetDlgBaseUnits adjustment only if colm size explicit L107

***************************************************************************/

#include "fivewin.ch"
#define DT_LEFT              0
#define DT_CENTER            1
#define DT_RIGHT             2

CLASS TCColumn

  DATA cHeading  AS CHAR     // Optional Header text
  DATA bData     AS BLOCK    // Mandatory Code block to return column data
  DATA cPicture  AS CHAR     // Ooptional picture clause
  DATA bClrFore  AS BLOCK    // Optional Foreground Color block
  DATA bClrBack  AS BLOCK    // Optional Background Color block
  DATA nAlign    AS NUMERIC  // Optional Alignement DT_LEFT or so on
  DATA nWidth    AS NUMERIC  // Optional Width
  DATA lBitMap   AS LOGICAL  // Optional Bitmap Flag
  DATA lEdit     AS LOGICAL  // True if editing is allowable
  DATA lNoLite   AS LOGICAL  // True to skip cell during SelectlLine()
  DATA cMsg      AS CHAR     // Editing message
  DATA bValid    AS BLOCK    // Editing valid block
  DATA cError    AS CHAR     // Bad valid error message
  DATA cOrder	   AS CHAR     // index tag name

  METHOD New( cHeading, bData, cPicture, bClrFore, bClrBack, ;
       uAlign, nWidth, lBitMap, lEdit, cMsg, bValid, cError, ;
       lNoLite, cOrder ) CONSTRUCTOR

ENDCLASS

METHOD New( cHeading, bData, cPicture, bClrFore, bClrBack, ;
      uAlign, nWidth, lBitMap, lEdit, cMsg, bValid, cError, ;
      lNoLite, cOrder ) CLASS TCColumn

      Local lAdj := .f.

       If cMsg == nil
         cMsg := "Press Esc to cancel"
       else
         cMsg += ",   press Esc to cancel"
       endif

       DEFAULT cHeading   := "", ;
               bData      := {|| nil }, ;
               cPicture   := nil, ;
               lBitMap    := .f., ;
               lEdit      := .f., ;
               lNoLite    := .f., ;
               cOrder     := "",  ;
               bValid     := {|| .t. }

     if nWidth == nil
        nWidth     := If( !lBitMap , ;
                  0.67*GetTextWidth( 0, Replicate( "B", ;
                                  Max( Len( cHeading ), ;
                                Len( If(Empty(cPicture), ;
                            cValToChar(Eval( bData )), ;
        Tran( Eval( bData ), cPicture) ) ) )+ 1 ), 0 ), 16)   
                                                //^
                  //   If( ! Empty( ::oFont ), ::oFont:hFont,) ) 
      else
        lAdj := .t. // adjust for diff system font only if explict size
      endif

      if ValType( uAlign ) == "C"
        uAlign := AScan( {"LEFT","CENTER","RIGHT"}, {|c| uAlign $ c }) - 1
        uAlign := If( uAlign < 0, DT_LEFT, uAlign)
      elseif ValType( uAlign ) == "N" .and. (uAlign >= 0 .and. uAlign <= 2)
        // it is legal
      else
        uAlign   := DT_LEFT  // Default Left Align
      endif

      if bClrFore != nil .and. ValType( Eval(bClrFore) ) == "C"
        // It is a dBase Color string
        ::bClrFore := { || nGetForeRGB( Eval(bClrFore) ) }
        ::bClrBack := { || nGetBackRGB( Eval(bClrFore) ) }
      else
        if bClrFore != nil .and. !Empty(Eval(bClrFore))
          ::bClrFore := bClrFore
        endif
        if bClrBack != nil .and. !Empty(Eval(bClrBack))
          ::bClrBack := bClrBack
        endif
      endif

      ::cOrder 	  := cOrder
      ::cHeading 	:= cHeading
      ::bData    	:= bData
      ::cPicture 	:= cPicture
      ::nAlign   	:= uAlign
      ::nWidth   	:= nWidth * If( lAdj, ;
                             nLoWord(GetDlgBaseUnits())/ 8, 1) // 8 std 8x16 font6
      ::lBitMap  	:= lBitMap 
      ::lEdit    	:= lEdit
      ::lNoLite  	:= lNoLite
      ::cMsg     	:= cMsg 
      ::bValid   	:= bValid
      ::cError   	:= cError
	
Return( Self )

