// Under construction - Not available yet!

#include "fivewin.ch"

//----------------------------------------------------------------------------//

CLASS TDict

   DATA   aDbfs, aFlds, aIndexes, aViews, aBrws
   DATA   cPath

   METHOD New( cPath ) CONSTRUCTOR

   METHOD Load()

   METHOD Create() INLINE ASend( ::aDbfs, "Create", ::cPath ),;
                          ASend( ::aIndexes, "Create", ::cPath )

   METHOD Import( cDbfFile )

ENDCLASS

//----------------------------------------------------------------------------//

METHOD New( cPath ) CLASS TDict

   local cOldSel := Select()

   ::cPath    = cPath
   ::aDbfs    = {}
   ::aFlds    = {}
   ::aIndexes = {}
   ::aViews   = {}
   ::aBrws    = {}


   lMkDir( cPath )

   IF !file(cPath + "\database.dbf")
      dbcreate( cPath + "\database.dbf",;
                { {"NAME      ", "C",  8, 0 } , ;
                { "ALIAS     ", "C", 10, 0 } , ;
                { "SHARED    ", "L", 01, 0 } , ;
                { "COMMENTS  ", "C", 45, 0 } } )
   ENDIF

   IF !file(cPath + "\database.ntx")
      use (cPath + "\database.dbf") NEW ALIAS Dbfs
      index on FIELD->name TO ( cPath + "\DataBase.ntx" ) //  tag name
      USE
   ENDIF

   IF !file(cPath + "\fields.dbf")
      dbcreate(cPath + "\fields.dbf",;
               { {"DBFNAME   ", "C",  8, 0 } , ;
                 {"ORDER     ", "N", 02, 0 } , ;
                 {"INDEXED   ", "L", 01, 0 } , ;
                 {"NAME      ", "C", 10, 0 } , ;
                 {"TYPE      ", "C", 01, 0 } , ;
                 {"WIDTH     ", "N", 03, 0 } , ;
                 {"DECIMAL   ", "N", 03, 0 } , ;
                 {"COMMENTS  ", "C", 45, 0 } } )
   ENDIF

   IF !file(cPath + "\fields.ntx")
      use (cPath + "\fields.dbf") NEW ALIAS Flds
      index on FIELD->dbfname  TO ( cPath + "\fields.ntx" ) // tag dbfname
      // index on FIELD->order    tag order
      USE
   ENDIF

   IF ! file( cPath + "\INDEXES.dbf" )
              dbcreate(cPath + "\indexes.dbf",;
                       { {"DBFNAME   ", "C",  8, 0 } , ;
                         {"NAME      ", "C", 10, 0 } , ;
                         {"EXPRESSION", "C", 120,0 } , ;
                         {"TAG       ", "C",  8, 0 } , ;
                         {"UNIQUE    ", "L", 001,0 } , ;
                         {"DESCENDING", "L", 001,0 } , ;
                         {"COMMENTS  ", "C", 45, 0 } } )
   ENDIF

   IF !file(cPath + "\indexes.cdx")
      use (cPath + "\indexes.dbf") NEW ALIAS Indxs
      index on FIELD->dbfname TO ( cPath + "\Indexes.ntx" ) //  tag dbfname
      USE
   ENDIF

	IF !file(cPath + "\VIEWS.dbf")
				dbcreate(cPath + "\VIEWS.dbf",;
				 { {"NAME      ", "C", 10, 0 } , ;
					{"DATABASE  ", "C", 10, 0},;
					{"ORDER     ", "N", 02, 0},;
					{"REL01     ", "C", 15, 0},;
					{"REL02     ", "C", 15, 0},;
					{"REL03     ", "C", 15, 0},;
					{"REL04     ", "C", 15, 0},;
					{"REL05     ", "C", 15, 0},;
					{"REL06     ", "C", 15, 0},;
					{"REL07     ", "C", 15, 0},;
					{"REL08     ", "C", 15, 0},;
					{"INTO01    ", "C", 15, 0},;
					{"INTO02    ", "C", 15, 0},;
					{"INTO03    ", "C", 15, 0},;
					{"INTO04    ", "C", 15, 0},;
					{"INTO05    ", "C", 15, 0},;
					{"INTO06    ", "C", 15, 0},;
					{"INTO07    ", "C", 15, 0},;
					{"INTO08    ", "C", 15, 0},;
					{"COMMENTS  ", "C", 45, 0 } } )
	ENDIF

	select(cOldSel)
return(NIL)

//----------------------------------------------------------------------------//


METHOD Load() CLASS TDict

   local cOldSel := select()

   USE (::cPath + "\fields.dbf") ALIAS Flds NEW
   SET INDEX TO ( ::cPath + "\fields.ntx" )

   USE (::cPath + "\indexes.dbf") ALIAS Indexes NEW
   SET INDEX TO ( ::cPath + "\indexes.ntx" )

   USE (::cPath + "\database.dbf") ALIAS Dbfs NEW
   SET INDEX TO ( ::cPath + "\database.dbf" )

   SET RELATION TO Dbfs->Name INTO Indexes
   SET RELATION TO Dbfs->Name INTO Flds

   while ! Dbfs->( eof())
      AAdd( ::aDbfs, TDbf():New( Dbfs->Name, Dbfs->ALIAS ) )

      while ! Flds->( eof() )
         AAdd( ATail( ::aDbfs ):aFields,;
               TField():New( Flds->DBFNAME  ,;
                             Flds->ORDER    ,;
                             Flds->INDEXED  ,;
                             Flds->NAME     ,;
                             Flds->TYPE     ,;
                             Flds->WIDTH    ,;
                             Flds->DECIMAL  ,;
                             Flds->COMMENTS ))
                             Flds->( DbSkip())
      end

      while ! indexes->( eof())
         AADD( ATail( ::aDbfs ):aIndexes,;
               TIndex():New( Indexes->DbfName,;
                             Indexes->Name,;
                             Indexes->EXPRESSION,;
                             Indexes->TAG       ,;
                             Indexes->UNIQUE    ,;
                             Indexes->DESCENDING,;
                             Indexes->COMMENTS  ))
         Indexes->( dbSkip())
      end
      Dbfs->( dbSkip())
   end

   Flds->( dbClosearea())
   Dbfs->( dbClosearea())

   Select( cOldSel )

return nil

//----------------------------------------------------------------------------//

METHOD Import( cDbfFile ) CLASS TDict

   AAdd( ::aDbfs, TDbf():Import( cDbfFile ) )

return nil

//----------------------------------------------------------------------------//
