#include "FiveWin.ch"

//----------------------------------------------------------------------------//

CLASS TMsgItem  
   
   DATA   oMsgBar
   DATA   cMsg
   DATA   nSize, nClrFore, nClrBack, nId
   DATA   bMsg
   DATA   oFont

   METHOD New( oMsgBar, cMsg, nSize, oFont, nClrFore, nClrBack, lAdd ) CONSTRUCTOR
   
   METHOD Refresh() INLINE If( ::bMsg != Nil,;
                               ::cMsg := cValToChar( Eval( ::bMsg ) ),),;
                               ::Show()
 
   METHOD SetFont( oFont ) INLINE ::oFont:End(), ::oFont := oFont
   METHOD Show()
  
   METHOD SetText( cMsg ) INLINE ::cMsg := cValToChar( cMsg ), ::Refresh()

ENDCLASS

//----------------------------------------------------------------------------//

METHOD New( oMsgBar, cMsg, nSize, oFont, nClrFore, nClrBack, lAdd ) CLASS TMsgItem

   DEFAULT nClrFore := oMsgBar:nClrFore,;
           nClrBack := oMsgBar:nClrBack,;
           nSize := 40, lAdd := .f., cMsg := ""  

   ::oMsgBar     = oMsgBar
   ::cMsg        = cMsg 
   ::nSize       = nSize 
   ::oFont       = If(oFont != NIl, oFont, ::oMsgBar:oFont)
   ::nId         = oMsgBar:GetItem() + 1
   ::nSize       = nSize 

   If Valtype(nClrFore) == "C"
      ::nClrFore := nGetForeRGB(nClrFore)
      ::nClrBack := nGetBackRGB(nClrFore)
   Else   
      ::nClrFore := nClrFore
      ::nClrBack := nClrBack
   Endif
      
   If lAdd
      oMsgBar:AddItem( Self )   
   Endif   

return nil

//----------------------------------------------------------------------------//

METHOD Show() CLASS TMsgItem
   
   local nCount, nClrBack, hDC
   local nPos := ::oMsgBar:nRight
   local oRect, oBrush 

   if ::nId > 0 
      For nCount := 1 to ::nId - 1
   
          nPos -= (::oMsgBar:aItem[nCount]:nSize + 4)
           
      Next
   
      nPos -= (::nSize - 2)
      oRect:= TRect():New(4, nPos - 1, 17, nPos + (::nSize - 7))
      If(ValType(::nClrFore) == "C", (::nClrBack := nGetBackRGB(::nClrFore),;
                 ::nClrFore := nGetForeRGB(::nClrFore)), )
      hDC := GetDC(::oMsgBar:hWnd)
      DrawMsgItem(hDC, ::cMsg, oRect, ::nClrFore, ::nClrBack, ::oFont:hFont) 
  
      ReleaseDC(::oMsgBar:hWnd, hDC)
   endif

return nPos        

//----------------------------------------------------------------------------//
