// FiveWin automatic error generation

#include "Error.ch"
#include "FWerror.ch"

external ProcName

#define _SUBSYS_       "FiveWin"

#define ERR_MESSAGE    1
#define ERR_SEVERITY   2
#define ERR_SUBSYS     3
#define ERR_ERR_NO     4

//----------------------------------------------------------------------------//

function __LowMemError()
return Eval( ErrorBlock(), _FWGenError( MEMORYLOW_ERROR ) )

//----------------------------------------------------------------------------//

FUNCTION _FWGenError( nError, cOperation )

 local aErr := { { "Non defined Id" , ES_CATASTROPHIC,, },;
                 { "Duplicated Id"  , ES_CATASTROPHIC,, },;
                 { "Cannot create Dialog Box" , ES_CATASTROPHIC,, },;
                 { "Memory Low" , ES_WARNING, "BASE", 1001 },;
                 { "GPF ocurred", ES_CATASTROPHIC,, } }

 local oError

 if nError > 0 .and. nError <= MAX_DEFINED_ERRORS

    oError = ErrorNew()
    
    oError:Severity    = aErr[ nError ][ ERR_SEVERITY ]
    oError:CanDefault  = oError:Severity < ES_CATASTROPHIC
    oError:SubSystem   = If( aErr[ nError ][ ERR_SUBSYS ] == nil,;
                        _SUBSYS_ ,;
                        aErr[ nError ][ ERR_SUBSYS ] )
    oError:SubCode     = If( aErr[ nError ][ ERR_ERR_NO ] == nil,;
                        nError,;
                        aErr[ nError ][ ERR_ERR_NO ] )
    oError:Description = aErr[ nError ][ ERR_MESSAGE ]
    oError:Operation   = cOperation

 endif

return oError

//----------------------------------------------------------------------------//
