#include <WinTen.h>
#include <Windows.h>
#include <ClipApi.h>

#define FD_HEIGHT    22
#define FD_BORDER     8

#define CLR_BLACK     0

#define SETBLACKPEN( hDC )  SelectObject( hDC, GetStockObject( BLACK_PEN ) )
#define SETWHITEPEN( hDC )  SelectObject( hDC, GetStockObject( WHITE_PEN ) )

//----------------------------------------------------------------------------//

CLIPPER TABSPAINT() // ( hWnd, hDC, aPrompts, aSizes, hFont1, hFont2,
                    //   nClrPane, nOption ) --> nil
{
   HWND hWnd     = ( HWND ) _parni( 1 );
   HDC hDC       = ( HDC ) _parni( 2 );
   HPEN hDarkPen = CreatePen( PS_SOLID, 1, RGB( 128, 128, 128 ) );
   WORD wPrompts = _VARRAYLEN( _param( 3, -1 ) );
   HFONT hFont1  = ( HFONT ) _parni( 4 );
   HFONT hFont2  = ( HFONT ) _parni( 5 );
   LONG rgbPane  = _parnl( 6 );
   WORD wOption  = _parni( 7 );
   WORD wWidth, wHeight, wLeft = 0, w, wSize;
   RECT rct;

   if( ! wPrompts )
      return;

   GetWindowRect( hWnd, &rct );
   wHeight = rct.bottom - rct.top;
   wWidth  = rct.right - rct.left;

   if( ! wWidth )
      return;

   wSize = wWidth / wPrompts;

   SETBLACKPEN( hDC );
   MoveTo( hDC, 0, wHeight );
   LineTo( hDC, 0, 5 );

   SETWHITEPEN( hDC );
   MoveTo( hDC, 1, wHeight - 1 );
   LineTo( hDC, 1, 5 );
   MoveTo( hDC, 2, wHeight - 1 );
   LineTo( hDC, 2, FD_HEIGHT + 1 ),

   SETBLACKPEN( hDC );
   MoveTo( hDC, 0, wHeight - 1 );
   LineTo( hDC, wWidth, wHeight - 1 );

   SETBLACKPEN( hDC );
   MoveTo( hDC, wWidth - 1, wHeight - 1 );
   LineTo( hDC, wWidth - 1, FD_HEIGHT - 1 );

   SelectObject( hDC, hDarkPen );
   MoveTo( hDC, 1, wHeight - 2 );
   LineTo( hDC, wWidth - 2, wHeight - 2 );
   MoveTo( hDC, 2, wHeight - 3 );
   LineTo( hDC, wWidth - 2, wHeight - 3 );
   MoveTo( hDC, wWidth - 2, wHeight - 2 );
   LineTo( hDC, wWidth - 2, FD_HEIGHT - 1 );
   MoveTo( hDC, wWidth - 3, wHeight - 2 );
   LineTo( hDC, wWidth - 3, FD_HEIGHT );

   for( w = 0; w < wPrompts; w++ )
   {
      SETBLACKPEN( hDC );
      MoveTo( hDC, wLeft, FD_HEIGHT - 1 );
      LineTo( hDC, wLeft, 4 );
      LineTo( hDC, wLeft + 4, 0 );
      LineTo( hDC, wLeft + wSize - 3, 0 );
      LineTo( hDC, wLeft + wSize + 1, 4 );
      LineTo( hDC, wLeft + wSize + 1, FD_HEIGHT );

      SETWHITEPEN( hDC );
      MoveTo( hDC, wLeft + 1, FD_HEIGHT - 1 );
      LineTo( hDC, wLeft + 1, 4 );
      LineTo( hDC, wLeft + 4, 1 );
      LineTo( hDC, wLeft + wSize - 2, 1 );

      SelectObject( hDC, hDarkPen );
      MoveTo( hDC, wLeft + wSize - 2, 2 );
      LineTo( hDC, wLeft + wSize, 4 );
      LineTo( hDC, wLeft + wSize, FD_HEIGHT + 1 );

      if( w + 1 != wOption )
      {
         SETBLACKPEN( hDC );
         MoveTo( hDC, wLeft, FD_HEIGHT - 1 );
         LineTo( hDC, wLeft + wSize + 1, FD_HEIGHT - 1 );

         SETWHITEPEN( hDC );
         MoveTo( hDC, wLeft + ( w == 0 ), FD_HEIGHT );
         LineTo( hDC, wLeft + wSize + IF( ( w + 1 ) < wPrompts, 2, 0 ), FD_HEIGHT );
         MoveTo( hDC, wLeft - 1 + IF( w == 0, 2, 0 ), FD_HEIGHT + 1 );
         LineTo( hDC, wLeft + wSize + IF( ( w + 1 ) < wPrompts, 2, -1 ), FD_HEIGHT + 1 );
         SelectObject( hDC, hFont1 );
      }
      else
      {
         SETWHITEPEN( hDC );
         MoveTo( hDC, wLeft + 1, FD_HEIGHT + 1 );
         LineTo( hDC, wLeft + 1, FD_HEIGHT - 2 );
         MoveTo( hDC, wLeft + 2, FD_HEIGHT + 1 );
         LineTo( hDC, wLeft + 2, 4 );
         LineTo( hDC, wLeft + 3, 2 );
         LineTo( hDC, wLeft + wSize - 3, 2 );
         MoveTo( hDC, wLeft + 3, 4 );
         LineTo( hDC, wLeft + 5, 2 );

         SelectObject( hDC, hDarkPen );
         MoveTo( hDC, wLeft + wSize - 3, 3 );
         LineTo( hDC, wLeft + wSize - 1, 5 );
         MoveTo( hDC, wLeft + wSize - 3, 2 );
         LineTo( hDC, wLeft + wSize - 1, 4 );
         LineTo( hDC, wLeft + wSize - 1, FD_HEIGHT + 2 );

         SelectObject( hDC, hFont2 );
      }
      
      rct.top    = 5;
      rct.left   = wLeft + FD_BORDER;
      rct.bottom = FD_HEIGHT - 3;
      rct.right  = wLeft + wSize - FD_BORDER;

      SetTextColor( hDC, CLR_BLACK );
      SetBkColor( hDC, rgbPane );
      DrawText( hDC, _parc( 3, w + 1 ), _parclen( 3, w + 1 ),
                &rct, DT_CENTER );

      wLeft += wSize + 1;

      if( ( wLeft + wSize + 2 ) > wWidth )
         wSize = wWidth - wLeft - 2;
   }

   SETBLACKPEN( hDC );
   MoveTo( hDC, wLeft, FD_HEIGHT - 1 );
   LineTo( hDC, wWidth, FD_HEIGHT - 1 );

   /*
   SETWHITEPEN( hDC );
   MoveTo( hDC, wLeft, FD_HEIGHT );
   LineTo( hDC, wWidth - 2, FD_HEIGHT );
   MoveTo( hDC, wLeft, FD_HEIGHT + 1 );
   LineTo( hDC, wWidth - 3, FD_HEIGHT + 1 );
   */

   DeleteObject( hDarkPen );
   SetBkColor( hDC, rgbPane );
   ReleaseDC( hWnd, hDC );
}

//----------------------------------------------------------------------------//
