#include "FiveWin.ch"

static oTmr, oWnd

//----------------------------------------------------------------------------//

function SetToolTips( lOnOff )

   if oTmr == nil
      if GetWndDefault() == nil
         MsgAlert( "Define a Window before activating ToolTips!" )
         return nil
      endif

      DEFINE TIMER oTmr INTERVAL 250 OF GetWndDefault() ; // 1000 => 1 second
         ACTION CheckToolTip()

      ACTIVATE TIMER oTmr
   else
      oTmr:End()
      oTmr = nil
   endif

return nil

//----------------------------------------------------------------------------//

static function CheckToolTip()

   local aMousePos := GetCursorPos()
   local hOldFont, hWndUnder, nAt
   local aWindows, aPos, oWndUnder, oFont

   if oWnd == nil

      oTmr:DeActivate()
      hWndUnder = WindowFromPoint( aMousePos[ 2 ], aMousePos[ 1 ] )
      aWindows  = GetAllWin()
      nAt       = AScan( aWindows, { | oWnd | ! Empty( oWnd ) .and. ;
                                             oWnd:hWnd == hWndUnder } )
      if nAt != 0
         oWndUnder = aWindows[ nAt ]
         if Empty( oWndUnder:cToolTip )
            oTmr:Activate()
            return nil
         endif
      else
         oTmr:Activate()
         return nil
      endif

      DEFINE FONT oFont NAME "Ms Sans Serif" SIZE 0, -8

      SysRefresh()

      DEFINE WINDOW oWnd FROM 0, 0 TO 1, 5 ;
         STYLE nOr( WS_POPUP, DS_SYSMODAL, WS_BORDER ) ;
         COLOR 0, RGB( 255, 255, 150 )

      aPos = { oWndUnder:nBottom + 2, 3 }

      ClientToScreen( oWndUnder:hWnd, aPos )

      oWnd:Move( aPos[ 1 ], aPos[ 2 ],;
                 GetTextWidth( 0, oWndUnder:cToolTip, oFont:hFont ) + 7, 17 )
      oWnd:Show()

      SetBkMode( oWnd:GetDC(), 1 )
      SetTextColor( oWnd:hDC, 0 )
      hOldFont = SelectObject( oWnd:hDC, oFont:hFont )
      TextOut( oWnd:hDC, 1, 2, oWndUnder:cToolTip )
      SelectObject( oWnd:hDC, hOldFont )
      oWnd:ReleaseDC()

      ToolTipWait( oWndUnder:hWnd )

      oWnd:End()
      oFont:End()
      oWnd = nil
      SysRefresh()
      oTmr:Activate()

   endif

return nil

//----------------------------------------------------------------------------//
